package com.example.rgb_seekbar_2_kotlin

import android.graphics.Color
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.widget.TextView
import android.widget.SeekBar
import androidx.constraintlayout.widget.ConstraintLayout

class MainActivity : AppCompatActivity() {

    var tvColor: TextView? = null
    var mycolor = intArrayOf(255, 0, 0)

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        setContentView(R.layout.activity_main)
        for (i in 0..2) {
            var myID = "sb_$i"

            var resID = resources.getIdentifier(myID, "id", packageName)
            val mySeekBar = findViewById(resID) as SeekBar
            mySeekBar.setOnSeekBarChangeListener(myListener)

            myID = "tv_$i"
            resID = resources.getIdentifier(myID, "id", packageName)
        }
        tvColor = findViewById<TextView>(R.id.tvColor)

    } //end onCreate

    //*****************************************************************************************
    // establish the listener of the seekbars 
    var myListener: SeekBar.OnSeekBarChangeListener = object : SeekBar.OnSeekBarChangeListener {
        override fun onProgressChanged(seekBar: SeekBar, i: Int, b: Boolean) {
            //get the seekbar's parent which is the constraint layout
            val myLayout = seekBar.parent as ConstraintLayout
            //get the seekbar's index with the layout
            val myIndex = myLayout.indexOfChild(seekBar)
            //get the child with the next index which is a TextView
            var myTextView = myLayout.getChildAt(myIndex + 1) as TextView
            //display the progress in that TextView
            myTextView.text = "" + i

            // loop through TextViews displaying array values and update array element values
            for (j in 0..2) {
                val myID = "tv_$j"

                val resID = resources.getIdentifier(myID, "id", packageName)
                myTextView = findViewById<TextView>(resID)
                //mycolor[j] = Integer.parseInt(myTextView.text.toString())
                mycolor[j] = myTextView.text.toString().toInt()
            }

            // change color to display to user
            tvColor?.setBackgroundColor(
                Color.argb(
                    255,
                    mycolor[0], mycolor[1], mycolor[2]
                )
            )
        }

        override fun onStartTrackingTouch(seekBar: SeekBar) {}

        override fun onStopTrackingTouch(seekBar: SeekBar) {}
    }

} //end MainActivity class
